# Object Oriented Programming Quicksheet Assessment

Pat, 

This is a thoughtful and substantial account of OOP, which makes sense since you have 
experience teaching AP CS A! In the same vein, and maybe relevant to your potential reorganization
of the course, one area you didn't touch on as much is when to 
choose OOP and when to choose a different problem-solving strategy. (Of course, if you're starting
with Java, this doesn't come up because Java has a strong commitment to OOP.) I guess this is an argument 
for approaching things like OOP more as practices and less as content--not easy to pull off given the
content demands of AP. 

In my own context, I've been thinking
about adding a module to MWC in which we solve the same problem using different paradigms. At a larger
scale, you can achieve the same thing by learning multiple programming languages. Imagine going from 
Java to Haskell!

I'm glad you found `retro-games` to be an effective framework for learning and creating a game. I plan to 
keep refining it; I'd be delighted to provide any kind of support that's useful if you decided to use 
it in your own teaching. More options:

- [Quest](http://cs.fablearn.org/docs/quest/), my first attempt at writing a game framework focused on 
  limiting cognitive load and pedagogy. I've got a bunch of MWC modules around Quest if interested. 
- [Python Arcade](https://api.arcade.academy/en/latest/), one level down from Quest, and quite a bit more 
  complex. A labor of love by its author.

-Chris


